package speiger.src.builder.mappers;

import java.util.regex.Pattern;

import speiger.src.builder.misc.RegexMatcher;
import speiger.src.builder.misc.RegexUtil;

public class LineMapper implements IMapper
{
	String searchValue;
	Pattern pattern;
	
	public LineMapper(String pattern)
	{
		this(pattern, pattern);
	}
	
	public LineMapper(String searchValue, String pattern)
	{
		this.searchValue = searchValue;
		this.pattern = Pattern.compile(pattern, Pattern.LITERAL);
	}
	
	@Override
	public String getSearchValue()
	{
		return searchValue;
	}
	
	@Override
	public String apply(String t)
	{
		RegexMatcher matcher = new RegexMatcher(pattern, t);
		try
		{
			if(matcher.find())
			{
				StringBuffer buffer = new StringBuffer();			
				do
				{
					int start = matcher.end() - 1;
					int[] result = RegexUtil.findFullLine(t, start);
					if(result != null)
					{
						matcher.appendReplacement(buffer, pattern.pattern());
						buffer.setLength(buffer.length() - (start - result[0]));
						matcher.skip(result[1] - start);
					}
	            } while (matcher.find());
	            matcher.appendTail(buffer);
	            return apply(buffer.toString());
			}
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		catch(Error error) 
		{
			System.out.println("Error with ["+pattern.pattern()+"] pattern");
			throw error;
		}
		return t;
	}
	
	
}
