package example;

import java.io.IOException;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.function.Consumer;

import speiger.src.builder.mappers.SimpleMapper;
import speiger.src.builder.processor.TemplateProcess;
import speiger.src.builder.processor.TemplateProcessor;

public class ExampleBuilder extends TemplateProcessor
{
	
	public static void main(String...args)
	{
		try
		{
			new ExampleBuilder().process(true);
		}
		catch(IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		catch(InterruptedException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public ExampleBuilder()
	{
		super(Paths.get("example/input"), Paths.get("example/output"), Paths.get("example"));
	}

	@Override
	protected void init()
	{
		
	}
	
	@Override
	protected boolean isFileValid(Path fileName)
	{
		return true;
	}
	
	@Override
	public void createProcesses(String fileName, Consumer<TemplateProcess> process)
	{
		process.accept(new TemplateProcess(fileName+".txt").addFlags("TEST0").addMapper(new SimpleMapper("TESTING", "Test2")));
	}
	
	@Override
	protected boolean relativePackages()
	{
		return false;
	}
	
	@Override
	protected boolean debugUnusedMappers()
	{
		return false;
	}
	
}
